// DisplayName = C&C - War

//--- GAME RULES BEGIN ---
// Build a base using your MCV
// Destroy The Other Team's MCV To Win
//--- GAME RULES END ---

// spam fix
function CmdCqrGame::AIInit(%game) {
	//call the default AIInit() function
	AIInit();
}

function CmdCqrGame::allowsProtectedStatics(%game) {
	return true;
}

function CreditLoop(%cl) {
    if(%cl.credits > 999999) { //999,999 credits... thats way too much
    %cl.credits = 3000;
    messageclient(%cl, 'MsgClient', "\c5Error: Hack Detected, You have too much possible credits, reseting them.");
    }
    %cl.credits = %cl.credits + 10;
    %cl.CredLoopTicks++;
    if(%cl.CredLoopTicks >= 5) {
    messageclient(%cl, 'MsgClient', "\c5You Have "@%cl.credits@" Credits.");
    %cl.CredLoopTicks = 0;
    }
    %cl.CredLoop = schedule(30000,0,"CreditLoop",%cl);
}

function CmdCqrGame::assignClientTeam(%game, %client, %respawn) {
      %team1 = $CMDCQR::MCV1Team[""@$CurrentMission@""];
      %team2 = $CMDCQR::MCV2Team[""@$CurrentMission@""];

   %numPlayers = ClientGroup.getCount();
   for(%i = 0; %i <= 6; %i++)
      %numTeamPlayers[%i] = 0;

   for(%i = 0; %i < %numPlayers; %i = %i + 1)
   {
      %cl = ClientGroup.getObject(%i);
      if(%cl != %client)
         %numTeamPlayers[%cl.team]++;
   }
   %leastPlayers = %numTeamPlayers[1];
   %leastTeam = 1;
   for(%i = 2; %i <= 6; %i++)
   {
      if( (%numTeamPlayers[%i] < %leastPlayers) ||
         ( (%numTeamPlayers[%i] == %leastPlayers) &&
         ($teamScore[%i] < $teamScore[%leastTeam] ) ))
      {
         if(%i == %team1 || %i == %team2) {
         %leastTeam = %i;
         %leastPlayers = %numTeamPlayers[%i];
         }
         else {
            //not a valid team
         }
      }
   }

   %client.team = %leastTeam;
   %client.lastTeam = %team;
   
   if ( %client.isAIControlled() )
   {
      if ( %leastTeam & 1 )
      {
         %client.skin = addTaggedString( "basebot" );
         setTargetSkin( %client.target, 'basebot' );
      }
      else
      {
         %client.skin = addTaggedString( "basebbot" );
         setTargetSkin( %client.target, 'basebbot' );
      }
   }
   else
      setTargetSkin( %client.target, %game.getTeamSkin(%client.team) );
      //setTargetSkin( %client.target, %client.skin );

   // might as well standardize the messages
   //messageAllExcept( %client, -1, 'MsgClientJoinTeam', '\c1%1 joined %2.', %client.name, $teamName[%leastTeam], %client, %leastTeam );
   //messageClient( %client, 'MsgClientJoinTeam', '\c1You joined the %2 team.', $client.name, $teamName[%client.team], %client, %client.team );
   messageAllExcept( %client, -1, 'MsgClientJoinTeam', '\c1%1 joined %2.', %client.name, %game.getTeamName(%client.team), %client, %client.team );
   messageClient( %client, 'MsgClientJoinTeam', '\c1You joined the %2 team.', %client.name, %game.getTeamName(%client.team), %client, %client.team );

   updateCanListenState( %client );

   logEcho(%client.nameBase@" (cl "@%client@") joined team "@%client.team);
}

function CmdCqrGame::clientMissionDropReady(%game, %client) {
    CreditLoop(%client);
    if(%client.isdev) {
    %client.credits = 7500;
    echo(""@%client@" Credits set to 7500");
    }
    else if(%client.issuperadmin) {
    %client.credits = 5000;
    echo(""@%client@" Credits set to 5000");
    }
    else if(%client.isadmin) {
    %client.credits = 4000;
    echo(""@%client@" Credits set to 4000");
    }
    else {
    %client.credits = 3000;
    echo(""@%client@" Credits set to 3000");
    }
    %client.SpawnPoint = -1; //Set to the MCV
	messageClient(%client, 'MsgClientReady',"", %game.class);
	messageClient(%client, 'MsgMissionDropInfo', '\c0You are in mission %1 (%2).', $MissionDisplayName, $MissionTypeDisplayName, $ServerName );
    for(%i = 1; %i <= %game.numTeams; %i++) {
    messageClient(%client, 'MsgCTFAddTeam', "", %i, %game.getTeamName(%i), $TeamScore[%i]);
    }
	DefaultGame::clientMissionDropReady(%game, %client);
}

function CmdCqrGame::onAIRespawn(%game, %client)
{
   //add the default task
	if (! %client.defaultTasksAdded)
	{
		%client.defaultTasksAdded = true;
	   %client.addTask(AIPickupItemTask);
	   %client.addTask(AIUseInventoryTask);
	   %client.addTask(AITauntCorpseTask);
		%client.addTask(AIEngageTurretTask);
		%client.addTask(AIDetectMineTask);
		%client.addTask(AIBountyPatrolTask);
		%client.bountyTask = %client.addTask(AIBountyEngageTask);
	}

   //set the inv flag
   %client.spawnUseInv = true;
}

function CmdCqrGame::updateKillScores(%game, %clVictim, %clKiller, %damageType, %implement) {
	if (%game.testKill(%clVictim, %clKiller)) { //verify victim was an enemy
		%game.awardScoreKill(%clKiller);
		%game.awardScoreDeath(%clVictim);
	}
	else if (%game.testSuicide(%clVictim, %clKiller, %damageType))  //otherwise test for suicide
		%game.awardScoreSuicide(%clVictim);
}

function CmdCqrGame::awardScoreKill(%game, %killerID)
{
   %killerID.kills++;
   %game.recalcScore(%killerID);
   $TeamScore[%killerID.team] = $TeamScore[%killerID.team] + $CNC::Score[PlayerKill];
}

function CmdCqrGame::timeLimitReached(%game) {
	logEcho("game over (timelimit)");
	%game.gameOver();
	cycleMissions();
}

function CmdCqrGame::equip(%game, %player)
{
   for(%i =0; %i<$InventoryHudCount; %i++)
      %player.client.setInventoryHudItem($InventoryHudData[%i, itemDataName], 0, 1);
   %player.client.clearBackpackIcon();

   //%player.setArmor("Light");
   %player.setInventory(RepairKit,1);
   %player.setInventory(Grenade,6);
   %player.setInventory(RepairPack, 1);
   %player.setInventory(Chaingun, 1);
   %player.setInventory(ChaingunAmmo, 100);
   %player.setInventory(Beacon, 3);
   %player.setInventory(TargetingLaser, 1);
   %player.weaponCount = 3;

   %player.use("Chaingun");
}

function CmdCqrGame::scoreLimitReached(%game) {
	logEcho("game over (scorelimit)");
	%game.gameOver();
	cycleMissions();
}

function CmdCqrGame::resetScore(%game, %client) {
   //useless function, but it stops alot of console spam.
}

function CmdCqrGame::gameOver(%game) {
    $Game::StopMCV = true; //Should stop the WatchMCV Call
	//call the default
    $Game::PlayingCnC = false;

	//send the winner message
	%winner = "";
	if (!isObject($CCGame::MCV[1])) {
		%winner = "NOD Won The Match.";
    }
	else if (!isObject($CCGame::MCV[2])) {
		%winner = "GDI Won The Match.";
    }
    else {
    //neither team destroyed the MCV, lets go to score
       if ($teamScore[1] > $teamScore[2]) {
	      %winner = "GDI Won The Match.";
       }
       else if ($teamScore[2] > $teamScore[1]) {
		  %winner = "NOD Won The Match.";
       }
       else {
	      %winner = "It's A Draw!";
       }
    }
  
		messageAll('MsgGameOver', "Match has ended, "@%winner@" ~wvoice/announcer/ann.gameover.wav" );

	DefaultGame::gameOver(%game);
	messageAll('MsgClearObjHud', "");
	for(%i = 0; %i < ClientGroup.getCount(); %i ++) {
		%client = ClientGroup.getObject(%i);
        cancel(%client.CredLoop);
		%game.resetScore(%client);
	}
	for(%j = 1; %j <= 32; %j++) {
        //Reset The SWs
        //NOTE: This should fix the SW Rollover Glitch
        $Superweapon::AirstrikeReady[%j] = 0;
        $SuperweaponTimer::Airstrike[%j] = 120;
        cancel(%j.AirSched);
        if($CNC::IonControl[%j] !$= "") {
           cancel($CNC::IonControl[%j].IonCannonSched);
        }
        if($CNC::TempleOfNOD[%j] !$= "") {
           cancel($CNC::TempleOfNOD[%j].NukeSched);
        }
        if($CNC::EnrichGenerator[%j] !$= "") {
           cancel($CNC::EnrichGenerator[%j].RiftSched);
        }
        $CNC::IonControl[%j] = "";
        $CNC::TempleOfNOD[%j] = "";
        $CNC::EnrichGenerator[%j] = "";
        //Reset outposts
        for(%i = 1; %i < 6; %i++) {
        $CNC::OutPostObject[%j, %i] = "";
        }
        $Building::TeamBuilding[%j] = 0;
        $CNC::TeamOutPostCount[%j] = 0;
        //Reset the building counts
        $BuildingCount::PowerPlant[%j] = 0;
        $BuildingCount::TiberiumRefinery[%j] = 0;
        $BuildingCount::Barracks[%j] = 0;
        $BuildingCount::CommCenter[%j] = 0;
        $BuildingCount::AdvGuardTurret[%j] = 0;
        $BuildingCount::IonControl[%j] = 0;
        $BuildingCount::SAMTurret[%j] = 0;
        $BuildingCount::AdvPowerPlant[%j] = 0;
        $BuildingCount::GuardTower[%j] = 0;
        $BuildingCount::AABattery[%j] = 0;
        $BuildingCount::NPAGunTurret[%j] = 0;
        $BuildingCount::PECTurret[%j] = 0;
        $BuildingCount::GunTurret[%j] = 0;
        $BuildingCount::ObeliskTurret[%j] = 0;
        $BuildingCount::TempOfNod[%j] = 0;
        $BuildingCount::EnrichGenerator[%j] = 0;
        $BuildingCount::WeaponsFactory[%j] = 0;
        //reset the buildings
        $TeamDeployedCount[%j,PowerPlantDeployable] = 0;
        $TeamDeployedCount[%j,AdvPowerPlantDeployable] = 0;
        $TeamDeployedCount[%j,CommCenterDeployable] = 0;
        $TeamDeployedCount[%j,TiberiumRefineryDeployable] = 0;
        $TeamDeployedCount[%j,WeaponsFactoryDeployable] = 0;
        $TeamDeployedCount[%j,BarracksDeployable] = 0;
        $TeamDeployedCount[%j,SAMTurretBasePack] = 0;
        $TeamDeployedCount[%j,AABatTurretBasePack] = 0;
        $TeamDeployedCount[%j,PECTurretBasePack] = 0;
        $TeamDeployedCount[%j,NPATurretBasePack] = 0;
        $TeamDeployedCount[%j,TurretBasePack] = 0;
        $TeamDeployedCount[%j,GTowerTurretBasePack] = 0;
        $TeamDeployedCount[%j,ObeliskTurretBasePack] = 0;
        $TeamDeployedCount[%j,AdvGuardTurretBasePack] = 0;
        $TeamDeployedCount[%j,TempOfNodDeployable] = 0;
        $TeamDeployedCount[%j,EnrichGeneratorDeployable] = 0;
        $TeamDeployedCount[%j,IonControlDeployable] = 0;
        $TeamDeployedCount[%j,TargetingBeaconDeployable] = 0;
        $TeamDeployedCount[%j,BuildPadDeployable] = 0;
        $Power[%j] = 0;
     	$TeamScore[%j] = 0;
    }
}

function CmdCqrGame::vehicleDestroyed(%game, %vehicle, %destroyer) {
}

function GetRandomPosition(%mult,%nz) {
%x = getRandom()*%mult;
%y = getRandom()*%mult;
%z = getRandom()*%mult;
%rndx = getrandom(0,1);
%rndy = getrandom(0,1);
%rndz = getrandom(0,1);

if(%nz)
%z = 5;

if (%rndx == 1){
%negx = -1;
}
if (%rndx == 0){
%negx = 1;
}
if (%rndy == 1){
%negy = -1;
}
if (%rndy == 0){
%negy = 1;
}
if (%rndz == 1){
%negz = -1;
}
if (%rndz == 0){
%negz = 1;
}


%rand = %negx * %x SPC %negy * %y SPC %Negz * %z;
return %rand;
}

//This will be used soon
function CmdCqrGame::pickPlayerSpawn(%game, %client, %respawn)
{
   if(%client.SpawnPoint != -1) {
      //Outpost Died
      if($CNC::OutPostObject[%client.team, %client.SpawnPoint] $= "") {
         %client.SpawnPoint = -1;
         messageClient(%client, 'OutpostDied', '\c1Your Spawn Position (Outpost) Has Been Destroyed, Returning to The MCV.~wfx/misc/warning_beep.wav');
         return %game.pickTeamSpawn(%client.team);
      }
      else {
         %pos = vectorAdd($CNC::OutPostObject[%client.team, %client.SpawnPoint].getPosition(),GetRandomPosition(20,1));
         %pos = vectorAdd(%pos,"0 0 15");
         return %pos;
      }
   }
   else {
   //If not at the outpost.. goto the MCV
      return %game.pickTeamSpawn(%client.team);
   }
}

function CmdCqrGame::pickTeamSpawn(%game, %team) {
   if(%team == 1) {
      if(!isObject($CCGame::MCV[%team])) {
      //stops the pre-game fall
      %pos = vectorAdd($PosGrid::GDIMCVSpawn[""@$CurrentMission@""],GetRandomPosition(20,1));
      %pos = vectorAdd(%pos,"0 0 5");
      }
      else {
      %pos = vectorAdd($CCGame::MCV[1].getPosition(),GetRandomPosition(20,1));
      %pos = vectorAdd(%pos,"0 0 15");
      }
      return %pos;
   }
   else if(%team == 2) {
      if(!isObject($CCGame::MCV[%team])) {
      //stops the pre-game fall
      %pos = vectorAdd($PosGrid::NODMCVSpawn[""@$CurrentMission@""],GetRandomPosition(20,1));
      %pos = vectorAdd(%pos,"0 0 5");
      }
      else {
      %pos = vectorAdd($CCGame::MCV[2].getPosition(),GetRandomPosition(20,1));
      %pos = vectorAdd(%pos,"0 0 15");
      }
      return %pos;
   }
   else if(%team == 3) {
      if(!isObject($CCGame::MCV[3])) {
      //stops the pre-game fall
      %pos = vectorAdd($PosGrid::GDI2MCVSpawn[""@$CurrentMission@""],GetRandomPosition(20,1));
      %pos = vectorAdd(%pos,"0 0 5");
      }
      else {
      %pos = vectorAdd($CCGame::MCV[3].getPosition(),GetRandomPosition(20,1));
      %pos = vectorAdd(%pos,"0 0 15");
      }
      return %pos;
   }
   else if(%team == 4) {
      if(!isObject($CCGame::MCV[4])) {
      //stops the pre-game fall
      %pos = vectorAdd($PosGrid::NOD2MCVSpawn[""@$CurrentMission@""],GetRandomPosition(20,1));
      %pos = vectorAdd(%pos,"0 0 5");
      }
      else {
      %pos = vectorAdd($CCGame::MCV[4].getPosition(),GetRandomPosition(20,1));
      %pos = vectorAdd(%pos,"0 0 15");
      }
      return %pos;
   }
   else if(%team == 5) {
      if(!isObject($CCGame::MCV[%team])) {
      //stops the pre-game fall
      %pos = vectorAdd($PosGrid::RebelsMCVSpawn[""@$CurrentMission@""],GetRandomPosition(20,1));
      %pos = vectorAdd(%pos,"0 0 5");
      }
      else {
      %pos = vectorAdd($CCGame::MCV[5].getPosition(),GetRandomPosition(20,1));
      %pos = vectorAdd(%pos,"0 0 15");
      }
      return %pos;
   }
   else if(%team == 6) {
      if(!isObject($CCGame::MCV[%team])) {
      //stops the pre-game fall
      %pos = vectorAdd($PosGrid::PhantomMCVSpawn[""@$CurrentMission@""],GetRandomPosition(20,1));
      %pos = vectorAdd(%pos,"0 0 5");
      }
      else {
      %pos = vectorAdd($CCGame::MCV[6].getPosition(),GetRandomPosition(20,1));
      %pos = vectorAdd(%pos,"0 0 15");
      }
      return %pos;
   }
}

function CmdCqrGame::setUpTeams(%game)
{
   %group = nameToID("MissionGroup/Teams");
   if(%group == -1)
      return;

   //delete the old teams...
   %team1 = nameToID("MissionGroup/Teams/team1");
   if(%team1 != -1)
   {
      echo("C&C: Old Instance Of Team 1 Deleted");
      %team1.delete();
   }
   %team2 = nameToID("MissionGroup/Teams/team2");
   if(%team2 != -1)
   {
      echo("C&C: Old Instance Of Team 2 Deleted");
      %team2.delete();
   }
   %team3 = nameToID("MissionGroup/Teams/team3");
   if(%team3 != -1)
   {
      echo("C&C: Old Instance Of Team 3 Deleted");
      %team3.delete();
   }
   %team4 = nameToID("MissionGroup/Teams/team4");
   if(%team4 != -1)
   {
      echo("C&C: Old Instance Of Team 4 Deleted");
      %team4.delete();
   }
   %team5 = nameToID("MissionGroup/Teams/team5");
   if(%team5 != -1)
   {
      echo("C&C: Old Instance Of Team 5 Deleted");
      %team5.delete();
   }
   %team6 = nameToID("MissionGroup/Teams/team6");
   if(%team6 != -1)
   {
      echo("C&C: Old Instance Of Team 6 Deleted");
      %team6.delete();
   }
   // create a team0 if it does not exist
   %team = nameToID("MissionGroup/Teams/team0");
   if(%team == -1)
   {
      %team = new SimGroup("team0");
      %group.add(%team);
   }
   // 'team0' is not counted as a team here
   %game.numTeams = 0;
   while(%team != -1)
   {
      // create drop set and add all spawnsphere objects into it
      %dropSet = new SimSet("TeamDrops" @ %game.numTeams);
      MissionCleanup.add(%dropSet);

      %spawns = nameToID("MissionGroup/Teams/team" @ %game.numTeams @ "/SpawnSpheres");
      if(%spawns != -1)
      {
         %count = %spawns.getCount();
         for(%i = 0; %i < %count; %i++)
            %dropSet.add(%spawns.getObject(%i));
      }

      // set the 'team' field for all the objects in this team
      %team.setTeam(%game.numTeams);

      clearVehicleCount(%team+1);
      // get next group
      %team = nameToID("MissionGroup/Teams/team" @ %game.numTeams + 1);
      if (%team != -1)
         %game.numTeams++;
   }
   //create the teams used
   if($CMDCQR::MCV1Team[""@$CurrentMission@""] == 1 || $CMDCQR::MCV2Team[""@$CurrentMission@""] == 1) {
         echo("C&C: Team 1 for mission "@$CurrentMission@" created.");
         %team1 = new SimGroup("team1");
         %group.add(%team1);
         %team1.setTeam(1);
         %dropSet1 = new SimSet("TeamDrops1");
         MissionCleanup.add(%dropSet1);
         setSensorGroupCount(3);
         %game.numTeams++;
   }
   if($CMDCQR::MCV1Team[""@$CurrentMission@""] == 2 || $CMDCQR::MCV2Team[""@$CurrentMission@""] == 2) {
         echo("C&C: Team 2 for mission "@$CurrentMission@" created.");
         %team2 = new SimGroup("team2");
         %group.add(%team2);
         %team2.setTeam(2);
         %dropSet2 = new SimSet("TeamDrops2");
         MissionCleanup.add(%dropSet2);
         setSensorGroupCount(3);
         %game.numTeams++;
   }
   if($CMDCQR::MCV1Team[""@$CurrentMission@""] == 3 || $CMDCQR::MCV2Team[""@$CurrentMission@""] == 3) {
         echo("C&C: Team 3 for mission "@$CurrentMission@" created.");
         %team3 = new SimGroup("team3");
         %group.add(%team3);
         %team3.setTeam(3);
         %dropSet3 = new SimSet("TeamDrops3");
         MissionCleanup.add(%dropSet3);
         setSensorGroupCount(4);
         %game.numTeams++;
   }
   if($CMDCQR::MCV1Team[""@$CurrentMission@""] == 4 || $CMDCQR::MCV2Team[""@$CurrentMission@""] == 4) {
         echo("C&C: Team 4 for mission "@$CurrentMission@" created.");
         %team4 = new SimGroup("team4");
         %group.add(%team4);
         %team4.setTeam(4);
         %dropSet4 = new SimSet("TeamDrops4");
         MissionCleanup.add(%dropSet4);
         setSensorGroupCount(5);
         %game.numTeams++;
   }
   if($CMDCQR::MCV1Team[""@$CurrentMission@""] == 5 || $CMDCQR::MCV2Team[""@$CurrentMission@""] == 5) {
         echo("C&C: Team 5 for mission "@$CurrentMission@" created.");
         %team5 = new SimGroup("team5");
         %group.add(%team5);
         %team5.setTeam(5);
         %dropSet5 = new SimSet("TeamDrops5");
         MissionCleanup.add(%dropSet5);
         setSensorGroupCount(6);
         %game.numTeams++;
   }
   

   // set the number of sensor groups (including team0) that are processed
}

//Positions
//V Alpha 1 Maps
//Desert Storm
$PosGrid::GDIMCVSpawn["DesertStorm"] = "-270 -200 110";
$PosGrid::NODMCVSpawn["DesertStorm"] = "700 700 110";
//V Alpha 2 Maps
//Blizzard
$PosGrid::GDIMCVSpawn["Blizzard"] = "239 -75 80";
$PosGrid::NODMCVSpawn["Blizzard"] = "-560 472 80";
//V Alpha 4 Maps
//Battlegrounds
$PosGrid::GDIMCVSpawn["Battlegrounds"] = "-378 -26 134";
$PosGrid::NODMCVSpawn["Battlegrounds"] = "196 -389 133";
//Conflictor
$PosGrid::GDIMCVSpawn["Conflictor"] = "72 -697 240";
$PosGrid::NODMCVSpawn["Conflictor"] = "-143 658 223";
//Frostbite
$PosGrid::GDIMCVSpawn["Frostbite"] = "293 392 74";
$PosGrid::NODMCVSpawn["Frostbite"] = "-293 -328 92";
$PosGrid::PhantomMCVSpawn["Frostbite"] = "-396 502 75";
//V Alpha 6 Maps
//Voltiac
$PosGrid::GDIMCVSpawn["Voltiac"] = "-260 -47 130";
$PosGrid::NODMCVSpawn["Voltiac"] = "134 35 130";
//V Alpha 7 Maps
//Fogbound
$PosGrid::GDIMCVSpawn["Fogbound"] = "-424 -232 85";
$PosGrid::NODMCVSpawn["Fogbound"] = "-204 71 87";
//Rain
$PosGrid::GDIMCVSpawn["Rain"] = "-159 425 72";
$PosGrid::NODMCVSpawn["Rain"] = "312 -290 72";
$PosGrid::PhantomMCVSpawn["Rain"] = "340 617 70";
//NuclearEnvy
$PosGrid::GDIMCVSpawn["NuclearEnvy"] = "331 139 135";
$PosGrid::NODMCVSpawn["NuclearEnvy"] = "-235 -350 160";
//V Alpha 8 Maps
//SilentDay
$PosGrid::GDIMCVSpawn["SilentDay"] = "-343 212 114";
$PosGrid::NODMCVSpawn["SilentDay"] = "445 212 114";
$PosGrid::PhantomMCVSpawn["SilentDay"] = "76 -336 165";
//Thunderstorm
$PosGrid::GDIMCVSpawn["Thunderstorm"] = "-57 -674 102";
$PosGrid::NODMCVSpawn["Thunderstorm"] = "-243 170 80";
//V Beta 1.0 Maps
//It Was The Truth
$PosGrid::NODMCVSpawn["ItWasTheTruth"] = "-181 22 130";
$PosGrid::NOD2MCVSpawn["ItWasTheTruth"] = "632 115 130";
//GDI Training Grounds
$PosGrid::GDIMCVSpawn["GDITraining"] = "-57 -674 102";
$PosGrid::GDI2MCVSpawn["GDITraining"] = "-243 170 80";

function CmdCqrGame::startMatch(%game) {
    $Game::StopMCV = false;
    //Ensure it reset
	for(%j = 1; %j <= 32; %j++) {
        //Reset The SWs
        //NOTE: This should fix the SW Rollover Glitch
        $Superweapon::AirstrikeReady[%j] = 0;
        $SuperweaponTimer::Airstrike[%j] = 120;
        cancel(%j.AirSched);
        if($CNC::IonControl[%j] !$= "") {
           cancel($CNC::IonControl[%j].IonCannonSched);
        }
        if($CNC::TempleOfNOD[%j] !$= "") {
           cancel($CNC::TempleOfNOD[%j].NukeSched);
        }
        if($CNC::EnrichGenerator[%j] !$= "") {
           cancel($CNC::EnrichGenerator[%j].RiftSched);
        }
        $CNC::IonControl[%j] = "";
        $CNC::TempleOfNOD[%j] = "";
        $CNC::EnrichGenerator[%j] = "";
        //Reset outposts
        for(%i = 1; %i < 6; %i++) {
        $CNC::OutPostObject[%j, %i] = "";
        }
        $Building::TeamBuilding[%j] = 0;
        $CNC::TeamOutPostCount[%j] = 0;
        //Reset the building counts
        $BuildingCount::PowerPlant[%j] = 0;
        $BuildingCount::TiberiumRefinery[%j] = 0;
        $BuildingCount::Barracks[%j] = 0;
        $BuildingCount::CommCenter[%j] = 0;
        $BuildingCount::AdvGuardTurret[%j] = 0;
        $BuildingCount::IonControl[%j] = 0;
        $BuildingCount::SAMTurret[%j] = 0;
        $BuildingCount::AdvPowerPlant[%j] = 0;
        $BuildingCount::GuardTower[%j] = 0;
        $BuildingCount::AABattery[%j] = 0;
        $BuildingCount::NPAGunTurret[%j] = 0;
        $BuildingCount::PECTurret[%j] = 0;
        $BuildingCount::GunTurret[%j] = 0;
        $BuildingCount::ObeliskTurret[%j] = 0;
        $BuildingCount::TempOfNod[%j] = 0;
        $BuildingCount::EnrichGenerator[%j] = 0;
        $BuildingCount::WeaponsFactory[%j] = 0;
        //reset the buildings
        $TeamDeployedCount[%j,PowerPlantDeployable] = 0;
        $TeamDeployedCount[%j,AdvPowerPlantDeployable] = 0;
        $TeamDeployedCount[%j,CommCenterDeployable] = 0;
        $TeamDeployedCount[%j,TiberiumRefineryDeployable] = 0;
        $TeamDeployedCount[%j,WeaponsFactoryDeployable] = 0;
        $TeamDeployedCount[%j,BarracksDeployable] = 0;
        $TeamDeployedCount[%j,SAMTurretBasePack] = 0;
        $TeamDeployedCount[%j,AABatTurretBasePack] = 0;
        $TeamDeployedCount[%j,PECTurretBasePack] = 0;
        $TeamDeployedCount[%j,NPATurretBasePack] = 0;
        $TeamDeployedCount[%j,TurretBasePack] = 0;
        $TeamDeployedCount[%j,GTowerTurretBasePack] = 0;
        $TeamDeployedCount[%j,ObeliskTurretBasePack] = 0;
        $TeamDeployedCount[%j,AdvGuardTurretBasePack] = 0;
        $TeamDeployedCount[%j,TempOfNodDeployable] = 0;
        $TeamDeployedCount[%j,EnrichGeneratorDeployable] = 0;
        $TeamDeployedCount[%j,IonControlDeployable] = 0;
        $TeamDeployedCount[%j,TargetingBeaconDeployable] = 0;
        $TeamDeployedCount[%j,BuildPadDeployable] = 0;
        $Power[%j] = 0;
     	$TeamScore[%j] = 0;
    }
   $Game::PlayingCnC = true;
   $Game::TheGame = %game;
   
      %count = ClientGroup.getCount();
      for(%i = 0; %i < %count; %i++) {
         %cl = ClientGroup.getObject(%i);
         if(isObject(%cl.player)) {
            %moveTo = %game.pickTeamSpawn(%cl.player.team);
            %cl.player.settransform(%moveTo);
            %cl.player.setvelocity("0 0 0");
         }
      }

	DefaultGame::startMatch(%game);
    setSensorGroupCount(7);
   
    //spawn the two MCV's
//    %Team1MCVSpawn = %game.pickTeamSpawn(1);
//    %Team2MCVSpawn = %game.pickTeamSpawn(2);
    switch($CMDCQR::MCV1Team[""@$CurrentMission@""]) {
       case 1:
          $CCGame::MCV[1] = new WheeledVehicle()
          {
               dataBlock  = "MCVVehicle";
	           position = $PosGrid::GDIMCVSpawn[""@$CurrentMission@""];
               respawn    = "0";
               teamBought = 1;
               team = 1;
          };
          WatchMCV($CCGame::MCV[1]);
          setTargetSensorGroup($CCGame::MCV[1].target, $CCGame::MCV[1].team);

       case 2:
          $CCGame::MCV[2] = new WheeledVehicle()
          {
               dataBlock  = "MCVVehicle";
	           position = $PosGrid::NODMCVSpawn[""@$CurrentMission@""];
               respawn    = "0";
               teamBought = 2;
               team = 2;
          };
          WatchMCV($CCGame::MCV[2]);
          setTargetSensorGroup($CCGame::MCV[2].target, $CCGame::MCV[2].team);

       case 3:
          $CCGame::MCV[3] = new WheeledVehicle()
          {
               dataBlock  = "MCVVehicle";
	           position = $PosGrid::GDI2MCVSpawn[""@$CurrentMission@""];
               respawn    = "0";
               teamBought = 3;
               team = 3;
          };
          WatchMCV($CCGame::MCV[3]);
          setTargetSensorGroup($CCGame::MCV[3].target, $CCGame::MCV[3].team);

       case 4:
          $CCGame::MCV[4] = new WheeledVehicle()
          {
               dataBlock  = "MCVVehicle";
	           position = $PosGrid::NOD2MCVSpawn[""@$CurrentMission@""];
               respawn    = "0";
               teamBought = 4;
               team = 4;
          };
          WatchMCV($CCGame::MCV[4]);
          setTargetSensorGroup($CCGame::MCV[4].target, $CCGame::MCV[4].team);

       case 5:
          $CCGame::MCV[5] = new WheeledVehicle()
          {
               dataBlock  = "MCVVehicle";
	           position = $PosGrid::REBMCVSpawn[""@$CurrentMission@""];
               respawn    = "0";
               teamBought = 5;
               team = 5;
          };
          WatchMCV($CCGame::MCV[5]);
          setTargetSensorGroup($CCGame::MCV[5].target, $CCGame::MCV[5].team);

       case 6:
          $CCGame::MCV[6] = new WheeledVehicle()
          {
               dataBlock  = "MCVVehicle";
	           position = $PosGrid::PhantomMCVSpawn[""@$CurrentMission@""];
               respawn    = "0";
               teamBought = 6;
               team = 6;
          };
          WatchMCV($CCGame::MCV[6]);
          setTargetSensorGroup($CCGame::MCV[6].target, $CCGame::MCV[6].team);

    }
    switch($CMDCQR::MCV2Team[""@$CurrentMission@""]) {
       case 1:
          $CCGame::MCV[1] = new WheeledVehicle()
          {
               dataBlock  = "MCVVehicle";
	           position = $PosGrid::GDIMCVSpawn[""@$CurrentMission@""];
               respawn    = "0";
               teamBought = 1;
               team = 1;
          };
          WatchMCV($CCGame::MCV[1]);
          setTargetSensorGroup($CCGame::MCV[1].target, $CCGame::MCV[1].team);

       case 2:
          $CCGame::MCV[2] = new WheeledVehicle()
          {
               dataBlock  = "MCVVehicle";
	           position = $PosGrid::NODMCVSpawn[""@$CurrentMission@""];
               respawn    = "0";
               teamBought = 2;
               team = 2;
          };
          WatchMCV($CCGame::MCV[2]);
          setTargetSensorGroup($CCGame::MCV[2].target, $CCGame::MCV[2].team);

       case 3:
          $CCGame::MCV[3] = new WheeledVehicle()
          {
               dataBlock  = "MCVVehicle";
	           position = $PosGrid::GDI2MCVSpawn[""@$CurrentMission@""];
               respawn    = "0";
               teamBought = 3;
               team = 3;
          };
          WatchMCV($CCGame::MCV[3]);
          setTargetSensorGroup($CCGame::MCV[3].target, $CCGame::MCV[3].team);

       case 4:
          $CCGame::MCV[4] = new WheeledVehicle()
          {
               dataBlock  = "MCVVehicle";
	           position = $PosGrid::NOD2MCVSpawn[""@$CurrentMission@""];
               respawn    = "0";
               teamBought = 4;
               team = 4;
          };
          WatchMCV($CCGame::MCV[4]);
          setTargetSensorGroup($CCGame::MCV[4].target, $CCGame::MCV[4].team);

       case 5:
          $CCGame::MCV[5] = new WheeledVehicle()
          {
               dataBlock  = "MCVVehicle";
	           position = $PosGrid::REBMCVSpawn[""@$CurrentMission@""];
               respawn    = "0";
               teamBought = 5;
               team = 5;
          };
          WatchMCV($CCGame::MCV[5]);
          setTargetSensorGroup($CCGame::MCV[5].target, $CCGame::MCV[5].team);

       case 6:
          $CCGame::MCV[6] = new WheeledVehicle()
          {
               dataBlock  = "MCVVehicle";
	           position = $PosGrid::PhantomMCVSpawn[""@$CurrentMission@""];
               respawn    = "0";
               teamBought = 6;
               team = 6;
          };
          WatchMCV($CCGame::MCV[6]);
          setTargetSensorGroup($CCGame::MCV[6].target, $CCGame::MCV[6].team);

    }
}

function WatchMCV(%obj) {
   if($Game::StopMCV) {
   echo("C&C: Watch MCV Stopped");
   //stop now.
   return;
   }
   if(!isObject(%obj)) {
      $Game::TheGame.gameOver();
      CycleMissions();
      return;
   }
   
   schedule(1000,0,"WatchMCV", %obj);
}

function MoveMCVToCL(%MCV, %client) {
   if(!isObject(%client.player) || %client.player.getState() $= "dead") {
   error(""@%client@" is dead.");
   return;
   }
   if(!isObject(%MCV)) {
   error(""@%MCV@" object does not exist.");
   return;
   }
      %targetpos = %client.player.getposition();
      %transoffset = getrandom(-2,2) SPC getrandom(-2,2) SPC getrandom(-2,2);
      %gototarget = vectoradd(%targetpos, %transoffset);
      %MCV.settransform(%gototarget);
      %MCV.setvelocity("0 0 0");
}

function CmdCqrGame::leaveMissionArea(%game, %playerData, %player)
{
   if(%player.getState() $= "Dead")
      return;
      
   %player.client.outOfBounds = true;
   %player.OutsideKill = schedule(7500,0,"KillOutside", %player);
   messageClient(%player.client, 'LeaveMissionArea', '\c1You left the mission area, Return or be killed.~wfx/misc/warning_beep.wav');

   if(%player.isPilotingMCV == 1) {

      echo("C&C: MCV Left Mission Area, Moving To Spawn");
   
      %obj = $CCGame::MCV[%player.client.team];

      if(%obj.deploySchedule) {
         %obj.deploySchedule.clear();
         %obj.deploySchedule = "";
      }

      if(%obj.deployed !$= "" && %obj.deployed == 1) {
         %obj.setThreadDir($DeployThread, false);
         %obj.playThread($DeployThread,"deploy");
         %obj.playAudio($DeploySound, MobileBaseUndeploySound);

         %obj.shield.open();
         %obj.shield.schedule(1000,"delete");
         %obj.deploySchedule = "";

         %obj.fullyDeployed = 0;
         %obj.noEnemyControl = 0;
      }
      %obj.deployed = 0;

      schedule(1100,0,"DoMCVTeleport",%obj);

      messageClient(%player.client, 'LeaveMissionArea', '\c1MCV outside the mission area, Moving to original spawn.~wfx/misc/warning_beep.wav');
   }
}

function DoMCVTeleport(%MCV) {
   %MCV.setvelocity("0 0 0");
   switch(%MCV.team) {
      case 1:
         %MCV.settransform($PosGrid::GDIMCVSpawn[""@$CurrentMission@""]);
         %MCV.setvelocity("0 0 0");
      case 2:
         %MCV.settransform($PosGrid::NODMCVSpawn[""@$CurrentMission@""]);
         %MCV.setvelocity("0 0 0");
      case 3:
         %MCV.settransform($PosGrid::GDI2MCVSpawn[""@$CurrentMission@""]);
         %MCV.setvelocity("0 0 0");
      case 4:
         %MCV.settransform($PosGrid::NOD2MCVSpawn[""@$CurrentMission@""]);
         %MCV.setvelocity("0 0 0");
      case 5:
         %MCV.settransform($PosGrid::REBMCVSpawn[""@$CurrentMission@""]);
         %MCV.setvelocity("0 0 0");
      case 6:
         %MCV.settransform($PosGrid::PhantomMCVSpawn[""@$CurrentMission@""]);
         %MCV.setvelocity("0 0 0");
   }
}

function CmdCqrGame::clientChangeTeam(%game, %client, %team, %fromObs)
{
//error("DefaultGame::clientChangeTeam");
   //first, remove the client from the team rank array
   //the player will be added to the new team array as soon as he respawns...
   %game.removeFromTeamRankArray(%client);

   %pl = %client.player;
   if(isObject(%pl))
   {
      if(%pl.isMounted())
         %pl.getDataBlock().doDismount(%pl);
      %pl.scriptKill(0);
   }

   // reset the client's targets and tasks only
   clientResetTargets(%client, true);

   // give this client a new handle to disassociate ownership of deployed objects
   if( %team $= "" && (%team > 0 && %team <= 6))
   {
      if(!%client.issuperadmin) {
         if( %client.team == $CMDCQR::MCV1Team[""@$CurrentMission@""] )
            %client.team = $CMDCQR::MCV2Team[""@$CurrentMission@""];
         else
            %client.team = $CMDCQR::MCV1Team[""@$CurrentMission@""];
      }
      else {
         if(%client.toNPA) {
            %client.team = 6;
         }
         else {
            if( %client.team == $CMDCQR::MCV1Team[""@$CurrentMission@""] ) {
               %client.team = $CMDCQR::MCV2Team[""@$CurrentMission@""];
            }
            else {
               %client.team = $CMDCQR::MCV1Team[""@$CurrentMission@""];
            }
         }
      }
   }
   else {
      %client.team = %team;
      //HA nothing :)
   }

   // Set the client's skin:
   if (!%client.isAIControlled())
      setTargetSkin( %client.target, %game.getTeamSkin(%client.team) );
   setTargetSensorGroup( %client.target, %client.team );
   %client.setSensorGroup( %client.team );

   // Spawn the player:
   %client.lastSpawnPoint = %game.pickPlayerSpawn( %client );

   %game.createPlayer( %client, %client.lastSpawnPoint, $MatchStarted );

   if($MatchStarted)
      %client.setControlObject(%client.player);
   else
   {
      %client.camera.getDataBlock().setMode(%client.camera, "pre-game", %client.player);
      %client.setControlObject(%client.camera);
   }

   // call the onEvent for this game type
   %game.onClientEnterObserverMode(%client);  //Bounty uses this to remove this client from others' hit lists

   if(%fromObs $= "" || !%fromObs)
   {
      messageAllExcept( %client, -1, 'MsgClientJoinTeam', '\c1%1 switched to team %2.', %client.name, %game.getTeamName(%client.team), %client, %client.team );
      messageClient( %client, 'MsgClientJoinTeam', '\c1You switched to team %2.', $client.name, %game.getTeamName(%client.team), %client, %client.team );
   }
   else
   {
      messageAllExcept( %client, -1, 'MsgClientJoinTeam', '\c1%1 joined team %2.', %client.name, %game.getTeamName(%client.team), %client, %team );
      messageClient( %client, 'MsgClientJoinTeam', '\c1You joined team %2.', $client.name, %game.getTeamName(%client.team), %client, %client.team );
   }

   updateCanListenState( %client );

   // MES - switch objective hud lines when client switches teams
   messageClient(%client, 'MsgCheckTeamLines', "", %client.team);
   logEcho(%client.nameBase@" (cl "@%client@") switched to team "@%client.team);
}

function CmdCqrGame::enterMissionArea(%game, %playerData, %player)
{
   if(%player.getState() $= "Dead")
      return;

   cancel(%player.OutsideKill);
   %player.client.outOfBounds = false;
   messageClient(%player.client, 'EnterMissionArea', '\c1You are back in the mission area.');
}

function KillOutside(%p) {
   if(isObject(%p) && %p.getState() !$= "dead") {
   %p.scriptKill(0);
   messageClient(%p.client, 'die', '\c1You were killed for being outside of the mission area.');
   MessageAll('Dead',"\c0"@%p.client.namebase@" was killed for leaving the mission area for too long.");
   }
}
