//C&C Tiberium Conflict Client
//
//Options Provided to The Client (coming soon!!)
//   - RADAR (Small Command Circuit)
//   - Button Icons From C&C
//   - some other stuff
$ClientVersion = 2;
function DisplayCCClientMessage(%client) {
   if(%client.ClientVersion != $ServerClientVersion) {
   commandToClient(%client, 'BottomPrint', "C&C Tiberium Conflict Client \n WARNING: Your Client Version ("@%client.ClientVersion@") Does Not Match The Server's Version ("@$ServerClientVersion@") \n Please Check To See That Your Version Is Compatible With Server Settings", 5, 3);
   }
   else {
   commandToClient(%client, 'BottomPrint', "C&C Tiberium Conflict Client \n C&C TC Client Version ("@%client.ClientVersion@") Detected and running properly.", 5, 3);
   }
}

function clientCmdSpecifyServerVersion(%Vsn) {
$ServerClientVersion = %Vsn;
}

function serverCmdDisableClient(%client) {
   %client.RunningModClient = 0;
   commandToClient(%client, 'BottomPrint', "C&C Tiberium Conflict Client \n WARNING: You have turned off your C&C TC Client", 5, 3);
}

function serverCmdSetClientCNC(%client) {
//   %client.RunningModClient = 1;  //<-- Don't turn this on just yet!
                                    // There are still some issues with this
   %client.ClientVersion = $ClientVersion;
   schedule(7500,0,"DisplayCCClientMessage",%client);
   echo("Got C&C Client On "@%client@".");
   //set name with the {C&C}Name Tag
   %tag = "{C&C}";
   %name = "\cp\c7" @ %tag @ "\c6" @ %client.namebase @ "\co";
   MessageAll( 'MsgClientNameChanged', "", %client.name, %name, %client );
   removeTaggedString(%client.name);
   %client.name = addTaggedString(%name);
   setTargetName(%client.target, %client.name);
}

//////TESTIG STUFF
package CNCCl {
function GMW_PlayerModel::update( %this ) {
   //get the group id
   %group = %this.getGroup();
   if (!isObject(CNCInfoRdo)) {
      %height = getWord(GMW_LightRdo.getPosition(),1)-120;

      new ShellRadioButton(CNCInfoRdo) {
         profile = "ShellRadioProfile";
         horizSizing = "right";
         vertSizing = "top";
         position = 0 SPC %height;
         extent = "80 30";
         minExtent = "26 27";
         visible = "1";
         hideCursor = "0";
         bypassHideCursor = "0";
         command = "GMW_PlayerModel.update();";
         helpTag = "0";
         text = "C&C Mod";
         longTextBuffer = "0";
         maxLength = "255";
         groupNum = "1";
      };
      %group.add(CNCInfoRdo);
      CNCInfoRdo.setPosition(0,%height);
   }
   if (!isObject(CNCInfoBucket)) {
      new ShellScrollCtrl(CNCInfoBucket) {
         profile = "NewScrollCtrlProfile";
         horizSizing = "width";
         vertSizing = "height";
         extent = getword(GMW_PlayerModel.extent, 0)-83 SPC getword(GMW_PlayerModel.extent, 1);
         minExtent = "24 24";
         visible = "0";
         hideCursor = "0";
         bypassHideCursor = "0";
         helpTag = "0";
         willFirstRespond = "1";
         hScrollBar = "alwaysOff";
         vScrollBar = "dynamic";
         constantThumbHeight = "0";
         defaultLineHeight = "15";
         childMargin = "0 3";
         fieldBase = "gui/shll_field";

         new GuiScrollContentCtrl(CNCInfoScrlr) {
            profile = "GuiDefaultProfile";
            horizSizing = "width";
            vertSizing = "bottom";
            position = "4 7";
            extent = getword(GMW_PlayerModel.extent, 0)-98 SPC getword(GMW_PlayerModel.extent, 1) - 14;
            minExtent = "8 8";
            visible = "1";
            hideCursor = "0";
            bypassHideCursor = "0";
            helpTag = "0";

            new GuiMLTextCtrl(CNCInfoText) {
               profile = "ShellAltTextProfile";
               horizSizing = "width";
               vertSizing = "bottom";
               extent = getword(CNCInfoScrlr.extent,0)-14 SPC 0;
               minExtent = "8 8";
               visible = "1";
               hideCursor = "0";
               bypassHideCursor = "0";
               helpTag = "0";
               lineSpacing = "2";
               allowColorChars = "1";
               maxChars = "-1";
            };
         };
      };
      %group.add(CNCInfoBucket);
      CNCInfoBucket.setPosition(83,0);
   }
   if ( CNCInfoRdo.getValue() ) {
      CNCInfoBucket.update(1);
      NPAInfoBucket.setVisible(0);
      GDIInfoBucket.setVisible(0);
      NODInfoBucket.setVisible(0);
      CNCInfoBucket.setVisible(1);
      %this.setVisible(0);
      return;
   }
   else {
   CNCInfoBucket.setVisible(0);
   %this.setVisible(1);
   }
   
   if (!isObject(GDIInfoRdo)) {
      %height = getWord(GMW_LightRdo.getPosition(),1)-30;

      new ShellRadioButton(GDIInfoRdo) {
         profile = "ShellRadioProfile";
         horizSizing = "right";
         vertSizing = "top";
         position = 0 SPC %height;
         extent = "80 30";
         minExtent = "26 27";
         visible = "1";
         hideCursor = "0";
         bypassHideCursor = "0";
         command = "GMW_PlayerModel.update();";
         helpTag = "Displays The GDI Info Page, You must have an active internet connection.";
         text = "About GDI";
         longTextBuffer = "0";
         maxLength = "255";
         groupNum = "1";
      };
      %group.add(GDIInfoRdo);
      GDIInfoRdo.setPosition(0,%height);
   }
   if (!isObject(GDIInfoBucket)) {
      new ShellScrollCtrl(GDIInfoBucket) {
         profile = "NewScrollCtrlProfile";
         horizSizing = "width";
         vertSizing = "height";
         extent = getword(GMW_PlayerModel.extent, 0)-83 SPC getword(GMW_PlayerModel.extent, 1);
         minExtent = "24 24";
         visible = "0";
         hideCursor = "0";
         bypassHideCursor = "0";
         helpTag = "0";
         willFirstRespond = "1";
         hScrollBar = "alwaysOff";
         vScrollBar = "dynamic";
         constantThumbHeight = "0";
         defaultLineHeight = "15";
         childMargin = "0 3";
         fieldBase = "gui/shll_field";

         new GuiScrollContentCtrl(GDIInfoScrlr) {
            profile = "GuiDefaultProfile";
            horizSizing = "width";
            vertSizing = "bottom";
            position = "4 7";
            extent = getword(GMW_PlayerModel.extent, 0)-98 SPC getword(GMW_PlayerModel.extent, 1) - 14;
            minExtent = "8 8";
            visible = "1";
            hideCursor = "0";
            bypassHideCursor = "0";
            helpTag = "0";

            new GuiMLTextCtrl(GDIInfoText) {
               profile = "ShellAltTextProfile";
               horizSizing = "width";
               vertSizing = "bottom";
               extent = getword(GDIInfoScrlr.extent,0)-14 SPC 0;
               minExtent = "8 8";
               visible = "1";
               hideCursor = "0";
               bypassHideCursor = "0";
               helpTag = "0";
               lineSpacing = "2";
               allowColorChars = "1";
               maxChars = "-1";
            };
         };
      };
      %group.add(GDIInfoBucket);
      GDIInfoBucket.setPosition(83,0);
   }
   if ( GDIInfoRdo.getValue() ) {
      GDIInfoBucket.update(1);
      NPAInfoBucket.setVisible(0);
      GDIInfoBucket.setVisible(1);
      NODInfoBucket.setVisible(0);
      CNCInfoBucket.setVisible(0);
      %this.setVisible(0);
      return;
   }
   else {
   GDIInfoBucket.setVisible(0);
   %this.setVisible(1);
   }
   
   if (!isObject(NODInfoRdo)) {
      %height = getWord(GMW_LightRdo.getPosition(),1)-60;

      new ShellRadioButton(NODInfoRdo) {
         profile = "ShellRadioProfile";
         horizSizing = "right";
         vertSizing = "top";
         position = 0 SPC %height;
         extent = "80 30";
         minExtent = "26 27";
         visible = "1";
         hideCursor = "0";
         bypassHideCursor = "0";
         command = "GMW_PlayerModel.update();";
         helpTag = "0";
         text = "About NOD";
         longTextBuffer = "0";
         maxLength = "255";
         groupNum = "1";
      };
      %group.add(NODInfoRdo);
      NODInfoRdo.setPosition(0,%height);
   }
   if (!isObject(NODInfoBucket)) {
      new ShellScrollCtrl(NODInfoBucket) {
         profile = "NewScrollCtrlProfile";
         horizSizing = "width";
         vertSizing = "height";
         extent = getword(GMW_PlayerModel.extent, 0)-83 SPC getword(GMW_PlayerModel.extent, 1);
         minExtent = "24 24";
         visible = "0";
         hideCursor = "0";
         bypassHideCursor = "0";
         helpTag = "0";
         willFirstRespond = "1";
         hScrollBar = "alwaysOff";
         vScrollBar = "dynamic";
         constantThumbHeight = "0";
         defaultLineHeight = "15";
         childMargin = "0 3";
         fieldBase = "gui/shll_field";

         new GuiScrollContentCtrl(NODInfoScrlr) {
            profile = "GuiDefaultProfile";
            horizSizing = "width";
            vertSizing = "bottom";
            position = "4 7";
            extent = getword(GMW_PlayerModel.extent, 0)-98 SPC getword(GMW_PlayerModel.extent, 1) - 14;
            minExtent = "8 8";
            visible = "1";
            hideCursor = "0";
            bypassHideCursor = "0";
            helpTag = "0";

            new GuiMLTextCtrl(NODInfoText) {
               profile = "ShellAltTextProfile";
               horizSizing = "width";
               vertSizing = "bottom";
               extent = getword(NODInfoScrlr.extent,0)-14 SPC 0;
               minExtent = "8 8";
               visible = "1";
               hideCursor = "0";
               bypassHideCursor = "0";
               helpTag = "0";
               lineSpacing = "2";
               allowColorChars = "1";
               maxChars = "-1";
            };
         };
      };
      %group.add(NODInfoBucket);
      NODInfoBucket.setPosition(83,0);
   }
   if ( NODInfoRdo.getValue() ) {
      NODInfoBucket.update(1);
      NPAInfoBucket.setVisible(0);
      GDIInfoBucket.setVisible(0);
      NODInfoBucket.setVisible(1);
      CNCInfoBucket.setVisible(0);
      %this.setVisible(0);
      return;
   }
   else {
   NODInfoBucket.setVisible(0);
   %this.setVisible(1);
   }
   
   if (!isObject(NPAInfoRdo)) {
      %height = getWord(GMW_LightRdo.getPosition(),1)-90;

      new ShellRadioButton(NPAInfoRdo) {
         profile = "ShellRadioProfile";
         horizSizing = "right";
         vertSizing = "top";
         position = 0 SPC %height;
         extent = "80 30";
         minExtent = "26 27";
         visible = "1";
         hideCursor = "0";
         bypassHideCursor = "0";
         command = "GMW_PlayerModel.update();";
         helpTag = "0";
         text = "About NPA";
         longTextBuffer = "0";
         maxLength = "255";
         groupNum = "1";
      };
      %group.add(NPAInfoRdo);
      NPAInfoRdo.setPosition(0,%height);
   }
   if (!isObject(NPAInfoBucket)) {
      new ShellScrollCtrl(NPAInfoBucket) {
         profile = "NewScrollCtrlProfile";
         horizSizing = "width";
         vertSizing = "height";
         extent = getword(GMW_PlayerModel.extent, 0)-83 SPC getword(GMW_PlayerModel.extent, 1);
         minExtent = "24 24";
         visible = "0";
         hideCursor = "0";
         bypassHideCursor = "0";
         helpTag = "0";
         willFirstRespond = "1";
         hScrollBar = "alwaysOff";
         vScrollBar = "dynamic";
         constantThumbHeight = "0";
         defaultLineHeight = "15";
         childMargin = "0 3";
         fieldBase = "gui/shll_field";

         new GuiScrollContentCtrl(NPAInfoScrlr) {
            profile = "GuiDefaultProfile";
            horizSizing = "width";
            vertSizing = "bottom";
            position = "4 7";
            extent = getword(GMW_PlayerModel.extent, 0)-98 SPC getword(GMW_PlayerModel.extent, 1) - 14;
            minExtent = "8 8";
            visible = "1";
            hideCursor = "0";
            bypassHideCursor = "0";
            helpTag = "0";

            new GuiMLTextCtrl(NPAInfoText) {
               profile = "ShellAltTextProfile";
               horizSizing = "width";
               vertSizing = "bottom";
               extent = getword(NPAInfoScrlr.extent,0)-14 SPC 0;
               minExtent = "8 8";
               visible = "1";
               hideCursor = "0";
               bypassHideCursor = "0";
               helpTag = "0";
               lineSpacing = "2";
               allowColorChars = "1";
               maxChars = "-1";
            };
         };
      };
      %group.add(NPAInfoBucket);
      NPAInfoBucket.setPosition(83,0);
   }
   if ( NPAInfoRdo.getValue() ) {
      NPAInfoBucket.update(1);
      NPAInfoBucket.setVisible(1);
      GDIInfoBucket.setVisible(0);
      NODInfoBucket.setVisible(0);
      CNCInfoBucket.setVisible(0);
      %this.setVisible(0);
      return;
   }
   else {
   NPAInfoBucket.setVisible(0);
   %this.setVisible(1);
   }
   Parent::update( %this );
   
}

function CleanTextsOut() {
CNCInfoText.setText("");
GDIInfoText.setText("");
NODInfoText.setText("");
NPAInfoText.setText("");
}


//CONNECT
function CNCInfoBucket::update( %this, %online ) {
   CleanTextsOut();
   CNCInfoText.setText("Connecting To Control Center. \n"); //<- Control Center is the Website
   if (%online) {
      %server = "home.comcast.net:80";
      if (!isObject(CommSend))
         %bite = new HTTPObject(CommSend){};
      else %bite = CommSend;
      %bite.Setting = 0;
      %filename = "/~fritzrob815/CCNews.txt";
      %bite.get(%server, %filename);
   }
   schedule(10000,0,"DoFailedCon", 1);
}

function DoFailedCon(%failnum) {
   if(%failnum == 1) {
      if(!CNCInfoBucket.upToDate) {
         CleanTextsOut();
         CNCInfoText.setText("Control Center Is Down \n Connecting To Outpost 1. \n");
         %server = "sourcecnctc.webs.com:80";
         if (!isObject(CommSend))
            %bite = new HTTPObject(CommSend){};
         else %bite = CommSend;
         %filename = "/CCNews.txt";
         %bite.get(%server, %filename);
         //schedule(15000,0,"DoFailedCon", 2);  //I highly doubt this one going down
         return;
      }
   }
   else {
      if(!CNCInfoBucket.upToDate) {
         CNCInfoText.setText("Both Servers are down. \n You may want to check your internet connection.");
         return;
      }
   }
}

function CNCInfoText::addLine( %this, %line ) {
   if (%line $= "**End") {
      CNCInfoBucket.upToDate = true;
      return;
   }
   %text = %this.getText();
   %line = detag( %line );
   %text = (%text $= "") ? %line : %text NL %line;
   %this.setText( %text );
}

function CommSend::onLine(%this, %line) {
   if(%this.Setting == 0) {
      CNCInfoText.addLine(%line);
   }
   else if(%this.Setting == 1) {
      GDIInfoText.addLine(%line);
   }
   else if(%this.Setting == 2) {
      NODInfoText.addLine(%line);
   }
   else if(%this.Setting == 3) {
      NPAInfoText.addLine(%line);
   }
}

function CommSend::onConnectFailed() {
   echo("-- Could not connect to server.");
}
function CommSend::onDisconnect(%this) {
   %this.delete();
}

function GDIInfoBucket::update( %this, %online ) {
   CleanTextsOut();
   GDIInfoText.setText("Connecting To GDI Control Center. \n"); //<- Control Center is the Website
   if (%online) {
      %server = "home.comcast.net:80";
      if (!isObject(CommSend))
         %bite = new HTTPObject(CommSend){};
      else %bite = CommSend;
      %bite.Setting = 1;
      %filename = "/~fritzrob815/GDINews.txt";
      %bite.get(%server, %filename);
   }
}

function GDIInfoText::addLine( %this, %line ) {
   if (%line $= "**End") {
      GDIInfoBucket.upToDate = true;
      return;
   }
   %text = %this.getText();
   %line = detag( %line );
   %text = (%text $= "") ? %line : %text NL %line;
   %this.setText( %text );
}

//NOD

function NODInfoBucket::update( %this, %online ) {
   CleanTextsOut();
   NODInfoText.setText("Connecting To Temple Prime. \n"); //<- Control Center is the Website
   if (%online) {
      %server = "home.comcast.net:80";
      if (!isObject(CommSend))
         %bite = new HTTPObject(CommSend){};
      else %bite = CommSend;
      %bite.Setting = 2;
      %filename = "/~fritzrob815/NODNews.txt";
      %bite.get(%server, %filename);
   }
}

function NODInfoText::addLine( %this, %line ) {
   if (%line $= "**End") {
      NODInfoBucket.upToDate = true;
      return;
   }
   %text = %this.getText();
   %line = detag( %line );
   %text = (%text $= "") ? %line : %text NL %line;
   %this.setText( %text );
}

//NPA

function NPAInfoBucket::update( %this, %online ) {
   CleanTextsOut();
   NPAInfoText.setText("Connecting To Crusader III Databanks. \n"); //<- Control Center is the Website
   if (%online) {
      %server = "home.comcast.net:80";
      if (!isObject(CommSend))
         %bite = new HTTPObject(CommSend){};
      else %bite = CommSend;
      %bite.Setting = 3;
      %filename = "/~fritzrob815/NPANews.txt";
      %bite.get(%server, %filename);
   }
}

function NPAInfoText::addLine( %this, %line ) {
   if (%line $= "**End") {
      NPAInfoBucket.upToDate = true;
      return;
   }
   %text = %this.getText();
   %line = detag( %line );
   %text = (%text $= "") ? %line : %text NL %line;
   %this.setText( %text );
}

//function CNCInfoBucket::update( %this) {
   //clean olds
//   CleanTextsOut();
//   CNCInfoText.setText("<Font:Arial Bold:18>Welcome To C&C Mod \n Mod Version: Beta 1.1" @
//   "\n\n<Font:Arial Bold:16>Mod Developers: Phantom139 and Alviss \n"@
//   "\nChanges To The Current Version: \n \n"@
//   "<Font:Arial Bold:14>- Max Base Defenses: Adv. 3, Reg. 5"@
//  "\n- GDI MRLS Unit, Cost: 1600"@
//   "\n- New NPA Buildings: Laser Battery, Particle Expulsion Cannon"@
//   "\n- Building Method Modified"@
//   "\n-- Build Times"@
//   "\n-- Deploy The Cons. Pad"@
//   "\n-You can now sell deployed buildings."@
//   "\n-NPA can now upgrade some units"@
//   "\n-NPA, Building Tiers added to the MCV"@
//   "\n-Added the 'Additional Options' to the Phantom Embasy"@
//   "\n-Added Server Shutdown For Hosts to use"@
//   "\n-Of Course, This new menu for C&C Client Users."@
//   "\n ...End Transmission.");
//}
};

if (!isActivePackage(CNCCl)) activatepackage (CNCCl);

