function reload(%script)
{
	compile(%script); // Added by JackTL - Duh!!
    exec(%script);
    %count = ClientGroup.getCount();

    for(%i = 0; %i < %count; %i++)
    {
        %cl = ClientGroup.getObject(%i);

        if(!%cl.isAIControlled()) // no sending bots datablocks.. LOL
            %cl.transmitDataBlocks(0); // all clients on server
    }
}

$CNC::ModVersion = "Beta 1.1";
$ServerClientVersion = 2;
//C&C TC Executes
exec("scripts/functionality/CNCClient.cs");
echo("C&C TC Client Script Loaded");
exec("scripts/functionality/scoremenucmds.cs");
exec("scripts/functionality/LoadScreen.cs");
exec("scripts/functionality/ChatCmds.cs");
exec("scripts/functionality/CNCAI.cs");
echo("Map Scripts Loading");
exec("scripts/functionality/MapScripting/Thunderstorm.cs");
echo("Map Scripts Loaded");
exec("scripts/functionality/ServerSetup.cs");
echo("Server Setup File Loaded");
echo("Loading C&C TC Buildings");
exec("scripts/functionality/CNCBuilding.cs");
echo("C&C TC - Construction Pad Loaded");
exec("scripts/packs/BuildingPacks/PowerPlant.cs");
echo("C&C TC - Power Plant Loaded");
exec("scripts/packs/BuildingPacks/Barracks.cs");
echo("C&C TC - Barracks Loaded");
echo("C&C TC - Hand Of NOD Loaded");
exec("scripts/packs/BuildingPacks/NodGunTurret.cs");
echo("C&C TC - Gun Turret Loaded");
exec("scripts/packs/BuildingPacks/GDIGuardTower.cs");
echo("C&C TC - Guard Tower Loaded");
exec("scripts/packs/BuildingPacks/TiberiumRefinery.cs");
echo("C&C TC - Tiberium Refinery Loaded");
exec("scripts/packs/BuildingPacks/WeaponsFactory.cs");
echo("C&C TC - Weapons Factory Loaded");
echo("C&C TC - War Factory Loaded");
exec("scripts/packs/BuildingPacks/NodSAMSite.cs");
echo("C&C TC - SAM Site Loaded");
exec("scripts/packs/BuildingPacks/GDIAABattery.cs");
echo("C&C TC - AA Battery Loaded");
exec("scripts/packs/BuildingPacks/AdvPowerPlant.cs");
echo("C&C TC - Adv Power Plant Loaded");
exec("scripts/packs/BuildingPacks/CommCenter.cs");
echo("C&C TC - Communications Center Loaded");
exec("scripts/packs/BuildingPacks/NodObelisk.cs");
echo("C&C TC - Obelisk Loaded");
exec("scripts/packs/BuildingPacks/AdvGuardTower.cs");
echo("C&C TC - Adv. Guard Tower Loaded");
exec("scripts/packs/BuildingPacks/TempleOfNOD.cs");
echo("C&C TC - Temple Of NOD Loaded");
exec("scripts/packs/BuildingPacks/IonCannonControl.cs");
echo("C&C TC - Ion Control Loaded");
exec("scripts/packs/BuildingPacks/EnrichGenerator.cs");
echo("C&C TC - Enrich Generator Loaded");
exec("scripts/packs/BuildingPacks/NPALaserBattery.cs");
echo("C&C TC - NPA Laser Battery Loaded");
exec("scripts/packs/BuildingPacks/NPAPEC.cs");
echo("C&C TC - NPA P.E.C");
exec("scripts/weapons/BOTH/BeaconLaser.cs");
echo("C&C TC - Superweapon Targeters Loaded");
DESwordBeam.maxRifleRange = 1.5;
ESwordBeam.maxRifleRange = 1.5;


//C&C TC Functions

//These functions will serve a purpose later.
function CheckPowerLowLevel(%team) {
   //Either Too Much Power, Or We Lost A Power Plant
   if($Power[%team] < 0) {
      %count = ClientGroup.getCount();
      for(%i = 0; %i < %count; %i++) {
         %cl = ClientGroup.getObject(%i);
         if(%cl.team == %team) {
         messageclient(%cl, 'MsgClient', "\c5Base Update: Low Power, Base Defenses And Superweapons Offline, Power Level: "@$Power[%team]@".");
         }
      }
      %count = MissionCleanup.getCount();
      for(%i = 0; %i < %count; %i++) {
         %obj = MissionCleanup.getObject(%i);
         if(%obj.getClassName() $= "Turret") {
            if(%obj.team == %team) {
               %obj.getDataBlock().LosePower(%obj);
            }
         }
      }
   }
}

//This one may be used later
function CheckPowerGoodLevel(%team) {
   //Either Power Plants Built, Or We Lost A Base Defense
   if($Power[%team] > 0) {
      %count = MissionCleanup.getCount();
      for(%i = 0; %i < %count; %i++) {
         %obj = MissionCleanup.getObject(%i);
         if(%obj.getClassName() $= "Turret") {
            if(%obj.team == %team) {
               %obj.getDataBlock().GainPower(%obj);
            }
         }
      }
   }
}

function SpawnProjectile(%type, %DB, %Pos, %dir, %src) {
   if(%src $= "") {
      %proj = new (%type)() {
      dataBlock = %DB;
      initialDirection = %dir;
      initialPosition = %Pos;
      damageFactor = 1;
      };
      MissionCleanup.Add(%proj);
   }
   else {
      if(!isObject(%src)) {
      return;
      }
      %proj = new (%type)() {
      dataBlock = %DB;
      initialDirection = %dir;
      initialPosition = %Pos;
      sourceObject = %src;
      damageFactor = 1;
      };
      MissionCleanup.Add(%proj);
   }
}

function ReturnAmmo(%obj, %AmmoDB, %am) {
   %obj.setInventory(%AmmoDB, %am, true);
   commandToClient( %obj.client, 'BottomPrint', "<spush><font:Tempus Sans ITC:22><color:ff3300>Weapon Reloaded With "@%am@" Ammo<spop>", 3, 2);
}
