//-------------------------------------------
// Mod information load screen - ZOD. z0ddm0d
// and Modified later by the T2CC
//-------------------------------------------

package loadmodinfo
{
   function sendLoadInfoToClient( %client ) {
	Parent::sendLoadInfoToClient(%client);
	schedule(1000, 0, "sendLoadscreen", %client);
   }

   function sendLoadscreen(%client){
	messageClient( %client, 'MsgGameOver', "");
    messageClient( %client, 'MsgClearDebrief', "" );

    messageClient(%client, 'MsgDebriefResult', "", "<Font:Arial Bold:18><Just:CENTER>"@$Host::GameName);
    messageClient(%client, 'MsgDebriefResult', "", "<Font:Arial Bold:16><Just:CENTER>Command & Conquer : Tiberium Conflict");

    %ModVersion = "\n<Font:Arial:16>C&C Tiberium Conflict" @
               "\n<Font:Arial:14>Version: "@$CNC::ModVersion@".";

    messageClient(%client, 'MsgDebriefAddLine', "", %ModVersion);

    %Credits = "\n<Font:Arial:16>Developer: Phantom139" @
               "\nCo Dev: Alviss" @
               "\nSite: http://www.the-construct.net/forums/showthread.php?t=1104";

    // this callback adds content to the bulk of the gui
    messageClient(%client, 'MsgDebriefAddLine', "", %Credits);

   %nextMission = findNextCycleMission();
   if($CNC::NoCSMissions) { //prevent Desert Storm From Being Called
      if(%nextMission $= "DesertStorm") {
         if(!$Game::PlayingSurvival) {
         %nextMission = "Fogbound"; //Goto the next mission, which is Fogbound
         }
         else {
         %nextMission = "DesertStorm";
         }
      }
   }
   if($CNC::SkipIncompletes) { //prevent incp. maps from showing
      if(%nextMission $= "GDITraining") {
      %nextMission = "NuclearEnvy"; //Goto the next mission, which is Nulcear Envy
      }
   }
   if($CNC::NoNuclearEnvy) { //prevent Nuclear Envy From Being Called
      if(%nextMission $= "NuclearEnvy") {
      %nextMission = "Rain"; //Goto the next mission, which is Rain
      }
   }
   $CNC::SwitchMission = %nextMission;
    
    %CurrentServInfo = "\n<Font:Arial:16>Server Information:" @
               "\n<Font:Arial:14>Match Time Limit: "@$Host::TimeLimit@"."@
               "\n<Font:Arial:14>Current Mission: "@$CurrentMission@"."@
               "\n<Font:Arial:14>Player Count: "@$HostGamePlayerCount@"/"@$Host::MaxPlayers@"."@
               "\n<Font:Arial:14>Next Mission: "@%nextMission@".";

    messageClient(%client, 'MsgDebriefAddLine', "", %CurrentServInfo);

    %Intro = "\n<Font:Arial:14>Welcome To C&C Tiberium Conflict" @
               "\n<Font:Arial:12>Bringing the C&C Universe to Tribes 2.";

    messageClient(%client, 'MsgDebriefAddLine', "", %Intro);
    
    %Icons = "\nDo you have the C&C : TC Client?" @
    "\nIf you can see the Icon below, you have it." @
    "\nServer Version: "@$ServerClientVersion@"." @
    "\n <bitmap:Nuke> \n \n \n" @
    "\nIf you Cannot see the Icon," @
    "\nThe Client Comes with The Latest Release.";
               
    messageClient(%client, 'MsgDebriefAddLine', "", %Icons);
    
    %ModHelp1 = "\n<Font:Arial:14>In C&C TC, you use the Score Menu (Default [F2])" @
               "\n<Font:Arial:14>For Example, To build you base, look at a deployed MCV" @
               "\n<Font:Arial:14>Then hit your Score Menu Key, Then you would click build";

    messageClient(%client, 'MsgDebriefAddLine', "", %ModHelp1);

    %ModHelp2 ="<Font:Arial:14>and then the building you would build. you can use the" @
               "\n<Font:Arial:14>Menu to also buy weapons and vehicles by looking at the" @
               "\n<Font:Arial:14>proper building then clicking on what you want to buy.";

    messageClient(%client, 'MsgDebriefAddLine', "", %ModHelp2);
    
    %TC2 =     "\n" @
               "\nWE SUPPORT TRIBES NEXT! Thanks to Thyth/Krash123" @
               "\nFor dedicating your time to bring our favorite game back to life!"@
               "\nhttp://www.tribesnext.com";
    messageClient(%client, 'MsgDebriefAddLine', "", %TC2);

   }
};
activatepackage(loadmodinfo);
