//ALL CREDIT TO THE HALO MOD
// ORIGINALLY CODED BY: SoldierOfLight
// Modified by Phantom139

///////////////THROW Attack
datablock TracerProjectileData(SwordThrowProjectile)
{
   doDynamicClientHits = true;

   directDamage        = 0.0001; //the damage is added once we attach the sword :P
   directDamageType    = $DamageType::DESwordThrow;
   explosion           = "ChaingunExplosion";
   splash              = ChaingunSplash;

   kickBackStrength  = 0.0;
   sound 				= ChaingunProjectile;

   dryVelocity       = 425.0;
   wetVelocity       = 100.0;
   velInheritFactor  = 1.0;
   fizzleTimeMS      = 3000;
   lifetimeMS        = 3000;
   explodeOnDeath    = false;
   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 3000;

   tracerLength    = 15.0;
   tracerAlpha     = false;
   tracerMinPixels = 6;
   tracerColor     = 211.0/255.0 @ " " @ 215.0/255.0 @ " " @ 120.0/255.0 @ " 0.75";
	tracerTex[0]  	 = "special/tracer00";
	tracerTex[1]  	 = "special/tracercross";
	tracerWidth     = 0.10;
   crossSize       = 0.20;
   crossViewAng    = 0.990;
   renderCross     = true;

   decalData[0] = ChaingunDecal1;
   decalData[1] = ChaingunDecal2;
   decalData[2] = ChaingunDecal3;
   decalData[3] = ChaingunDecal4;
   decalData[4] = ChaingunDecal5;
   decalData[5] = ChaingunDecal6;
};

datablock TracerProjectileData(ShredStartProjectile)
{
   doDynamicClientHits = true;

   directDamage        = 0.0001; //the damage is added once we attach the sword :P
   directDamageType    = $DamageType::DESwordThrow;
   explosion           = "ChaingunExplosion";
   splash              = ChaingunSplash;

   kickBackStrength  = 0.0;
   sound 				= ChaingunProjectile;

   dryVelocity       = 425.0;
   wetVelocity       = 100.0;
   velInheritFactor  = 1.0;
   fizzleTimeMS      = 300;
   lifetimeMS        = 300;
   explodeOnDeath    = false;
   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 3000;

   tracerLength    = 15.0;
   tracerAlpha     = false;
   tracerMinPixels = 6;
   tracerColor     = 211.0/255.0 @ " " @ 215.0/255.0 @ " " @ 120.0/255.0 @ " 0.75";
	tracerTex[0]  	 = "special/tracer00";
	tracerTex[1]  	 = "special/tracercross";
	tracerWidth     = 0.10;
   crossSize       = 0.20;
   crossViewAng    = 0.990;
   renderCross     = true;

   decalData[0] = ChaingunDecal1;
   decalData[1] = ChaingunDecal2;
   decalData[2] = ChaingunDecal3;
   decalData[3] = ChaingunDecal4;
   decalData[4] = ChaingunDecal5;
   decalData[5] = ChaingunDecal6;
};

//////////////////////////////////////////////////

datablock TargetProjectileData(DESwordBeam)
{
   directDamage        	= 0.0;
   hasDamageRadius     	= false;
   indirectDamage      	= 0.0;
   damageRadius        	= 0.0;
   velInheritFactor    	= 1.0;

   maxRifleRange       	= 1.5;
   beamColor           	= "1 0 0";

   startBeamWidth		= 0.1;
   pulseBeamWidth 	    = 0.1;
   beamFlareAngle 	    = 3.0;
   minFlareSize        	= 0.0;
   maxFlareSize        	= 0.0;
   pulseSpeed          	= 0.0;
   pulseLength         	= 0.0;

   textureName[0]      	= "special/nonlingradient";
   textureName[1]      	= "special/flare";
   textureName[2]      	= "special/pulse";
   textureName[3]      	= "skins/glow_Red";
};

datablock ItemData(DESword)
{
   className = Weapon;
   catagory = "Spawn Items";
   //$$ TODO - real shape file
   shapeFile = "stackable4m.dts";
   image = DESwordImage;
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
	pickUpName = "a set of beam swords";

   computeCRC = true;
   emap=true;
};

datablock ShapeBaseImageData(DESwordImage)
{
   className = WeaponImage;
   shapeFile = "turret_muzzlepoint.dts";
   offset = "0.1 0.7 0.2";
   item = DESword;
   emap = true;
   projectile = EnergyBolt;
   projectileType = EnergyProjectile;

   // State Data
   stateName[0] = "Activate";
   stateTransitionOnTimeout[0] = "ActivateReady";
   stateTimeoutValue[0] = 0.2;
   stateSequence[0] = "Activate";
   stateSound[0] = ChaingunSwitchSound;

   stateName[1] = "ActivateReady";
   stateTimeoutValue[1] = 0.01;
   stateScript[1] = "onActivateReady";
   stateTransitionOnTimeout[1] = "Ready";

   stateName[2] = "Ready";
   stateScript[2] = "onReady";
   stateTransitionOnTriggerDown[2] = "Fire";

   stateName[3] = "Fire";
   stateTransitionOnTimeout[3] = "Reload";
   stateFire[3] = true;
   stateAllowImageChange[3] = false;
   stateScript[3] = "onFire";

   stateName[4]                  = "Reload";
   stateTransitionOnTimeout[4]   = "Ready";
   stateTimeoutValue[4]          = 0.7;
   stateAllowImageChange[4]      = false;
   stateSound[3] = GruntSound;
};

datablock ShapeBaseImageData(ESwordImage4)
{
   shapeFile = "weapon_energy_vehicle.dts";
   offset = "-0.4 0.2 0";
   rotation = "1 0 0 -10";
};

datablock ShapeBaseImageData(ESwordImage5)
{
   shapeFile = "weapon_energy_vehicle.dts";
   offset = "-0.4 0.2 0.1";
   rotation = "-1.10478e-07 0.996195 -0.0871558 180";
};

function ChangeSwordMode(%this, %data) {  //This Is Easier To use
      if (!(getSimTime() > (%this.mineModeTime + 100)))
      return;
      %this.mineModeTime = getSimTime();
      %this.WeaponMode++;
      if (%this.WeaponMode > 3) {
         %this.WeaponMode = 0;
      }
      DispSwordInfo(%this);
      return;
}

function DispSwordInfo(%obj) {
   if(%obj.WeaponMode == 0) {
      commandToClient( %obj.client, 'BottomPrint', "<spush><font:Tempus Sans ITC:20><color:ff3300>Dual Swords \n Attack Set To: Slice Em \n Regular Slashes", 5, 3);
   }
   else if(%obj.WeaponMode == 1) {
      commandToClient( %obj.client, 'BottomPrint', "<spush><font:Tempus Sans ITC:20><color:ff3300>Dual Swords \n Attack Set To: Blade Throw \n Throws One of the blades. Impales Targets", 5, 3);
   }
   else if(%obj.WeaponMode == 2) {
      commandToClient( %obj.client, 'BottomPrint', "<spush><font:Tempus Sans ITC:20><color:ff3300>Dual Swords \n Attack Set To: Shreder \n Only Affects Players, Shifts to target, then shreds them to bits.", 5, 3);
   }
   else if(%obj.WeaponMode == 3) {
      commandToClient( %obj.client, 'BottomPrint', "<spush><font:Tempus Sans ITC:20><color:ff3300>Dual Swords \n Attack Set To: Phantom Rage \n Very Devestating, Slashes in a fury for some time, then must recharge.", 5, 3);
   }
}

function DESwordImage::onMount(%data,%obj,%slot)
{
   Parent::onMount(%data,%obj,%slot);
   %obj.mountImage(ESwordImage2,4);
   %obj.mountImage(ESwordImage3,5);
   %obj.mountImage(ESwordImage4,6);
   %obj.mountImage(ESwordImage5,7);
   %obj.usingDEsword = 1;
}

function DESwordImage::onUnmount(%data,%obj,%slot)
{
   Parent::onUnmount(%data,%obj,%slot);
   %obj.unMountImage(4);
   %obj.unMountImage(5);
   %obj.unMountImage(6);
   %obj.unMountImage(7);
   %obj.usingDEsword = 0;
   cancel(%obj.DESwordloop);
   cancel(%obj.DESwordcloakloop);
   if(isObject(%obj.beam1))
   {
      %obj.beam1.delete();
      %obj.beam1 = "";
   }
   if(isObject(%obj.beam2))
   {
      %obj.beam2.delete();
      %obj.beam2 = "";
   }
   if(isObject(%obj.beam3))
   {
      %obj.beam3.delete();
      %obj.beam3 = "";
   }
   if(isObject(%obj.beam4))
   {
      %obj.beam4.delete();
      %obj.beam4 = "";
   }
}

function DESwordImage::onActivateReady(%data,%obj,%slot) //small explosion
{
   %p = new TracerProjectile()
   {
      datablock = "ESwordExpCreater";
      initialPosition = %obj.getMuzzlePoint(%slot);
      initialDirection = %obj.getMuzzleVector(%slot);
   };
   %p = new TracerProjectile()
   {
      datablock = "ESwordExpCreater";
      initialPosition = %obj.getMuzzlePoint(%slot);
      initialDirection = %obj.getMuzzleVector(%slot);
   };
}

function DESwordImage::onReady(%data,%obj,%slot) //create beams
{
   DESwordloop(%obj);
   CheckDCloakLoop(%obj);
}

function CheckDCloakLoop(%obj) {
   if(!isObject(%obj) || %obj.getState() $= "dead") {
   return;
   }
   if(%obj.usingDEsword == 1) {
      if(%obj.isCloaked()) {
         if(isObject(%obj.beam1)) {
            %obj.beam1.delete();
            %obj.beam1 = "";
         }
         if(isObject(%obj.beam2)) {
            %obj.beam2.delete();
            %obj.beam2 = "";
         }
         if(isObject(%obj.beam3)) {
            %obj.beam3.delete();
            %obj.beam3 = "";
         }
         if(isObject(%obj.beam4)) {
            %obj.beam4.delete();
            %obj.beam4 = "";
         }
      }
   }
   %obj.DESwordcloakloop = schedule(25,0,CheckDCloakLoop,%obj);
}

function DESwordLoop(%obj)
{
   if(!isObject(%obj) || %obj.getState() $= "dead") {
   return;
   }
   if(%obj.usingDEsword == 0)
   {
      if(isObject(%obj.beam1))
         %obj.beam1.delete();
      if(isObject(%obj.beam2))
         %obj.beam2.delete();
      if(isObject(%obj.beam3))
         %obj.beam3.delete();
      if(isObject(%obj.beam4))
         %obj.beam4.delete();
      return;
   }
   %vec1 = %obj.getMuzzleVector(4);
   %vec2 = %obj.getMuzzleVector(5);
   %vec3 = %obj.getMuzzleVector(6);
   %vec4 = %obj.getMuzzleVector(7);
   %vec = %obj.getMuzzleVector(0);
   %vec2d = getWords(%vec,0,1) SPC "0";
   %left = vectorCross(%vec2d,"0 0 1");
   %up = vectorCross(%vec,%left);
   %up = vectorScale(%up,0.2);
   %down = vectorScale(%up,-1);
   %pos1 = %obj.getMuzzlePoint(5);
   %pos2 = %obj.getMuzzlePoint(4);
   %pos3 = %obj.getMuzzlePoint(7);
   %pos4 = %obj.getMuzzlePoint(6);
   %dir1 = vectorAdd(%vec1,%down);
   %dir2 = vectorAdd(%vec2,%up);
   %dir3 = vectorAdd(%vec3,%down);
   %dir4 = vectorAdd(%vec4,%up);
   if(!isObject(%obj.beam1) && !%obj.isCloaked())
   {
      %obj.beam1 = new TargetProjectile()
      {
         datablock = "DESwordBeam";
         initialPosition = %pos1;
         initialDirection = %dir1;
         sourceSlot = 4;
         sourceObject = %obj;
      };
   }
   if(!isObject(%obj.beam2) && !%obj.isCloaked())
   {
      %obj.beam2 = new TargetProjectile()
      {
         datablock = "DESwordBeam";
         initialPosition = %pos2;
         initialDirection = %dir2;
         sourceSlot = 5;
         sourceObject = %obj;
      };
   }
   if(!isObject(%obj.beam3) && !%obj.isCloaked())
   {
      %obj.beam3 = new TargetProjectile()
      {
         datablock = "DESwordBeam";
         initialPosition = %pos3;
         initialDirection = %dir3;
         sourceSlot = 6;
         sourceObject = %obj;
      };
   }
   if(!isObject(%obj.beam4) && !%obj.isCloaked())
   {
      %obj.beam4 = new TargetProjectile()
      {
         datablock = "DESwordBeam";
         initialPosition = %pos4;
         initialDirection = %dir4;
         sourceSlot = 7;
         sourceObject = %obj;
      };
   }
   %obj.DESwordloop = schedule(25,0,DESwordloop,%obj);
}

function DESwordImage::onFire(%data,%obj,%slot) //apply damage
{
   if(%obj.mustRecharge) {
      commandToClient( %obj.client, 'BottomPrint', "<spush><font:Tempus Sans ITC:20><color:ff3300>You are still recharging from the last attack", 5, 3);
      return;
   }
   if(%obj.isCloaked()) {
      %obj.setCloaked(false);
      %obj.reCloak = %obj.schedule(2500, "setCloaked", true );
   }
   %vec = %obj.getMuzzleVector(%slot);
   %pos = %obj.getMuzzlePoint(%slot);
   if(%obj.WeaponMode == 0) {
      %vec = vectorScale(%vec,1.5);
      %end = vectorAdd(%pos,%vec);
      %mask = $TypeMasks::VehicleObjectType | $TypeMasks::PlayerObjectType | $TypeMasks::StaticShapeObjectType;
      initContainerRadiusSearch(%end,1.0,%mask);
      while((%target = containerSearchNext()) != 0)
      {
         if(%target == %obj) //you can never be too careful
            return;
         %target.damage(%obj,%target.getWorldBoxCenter(),0.4,$DamageType::DESword);
         %p = new TracerProjectile()
         {
            datablock = "ESwordExpCreater";
            initialPosition = %target.getPosition();
            initialDirection = %obj.getMuzzleVector(%slot); //who cares?
         };
      }
   }
   else if(%obj.WeaponMode == 1) {
      %p = new (TracerProjectile)() {
      dataBlock = SwordThrowProjectile;
      initialDirection = %vec;
      initialPosition = %pos;
      sourceObject = %obj;
      damageFactor = 1;
      sourceSlot = %slot;
      };
      MissionCleanup.Add(%p);
   }
   else if(%obj.WeaponMode == 2) {
      %p = new (TracerProjectile)() {
      dataBlock = ShredStartProjectile;
      initialDirection = %vec;
      initialPosition = %pos;
      sourceObject = %obj;
      damageFactor = 1;
      sourceSlot = %slot;
      };
      MissionCleanup.Add(%p);
   }
   else if(%obj.WeaponMode == 3) {
      BeginRage(%obj);
   }
   //play anim
//   %obj.disableMove(true); //don't screw up the kewl animation ;)
//   %obj.schedule(500,disableMove,false);
}

function DESword::onThrow(%data,%obj,%plyr)
{
   %pos = %obj.getPosition();
   %p = new TracerProjectile()
   {
      datablock = "ESwordExpCreater";
      initialPosition = %pos;
      initialDirection = "0 0 1";
   };
   %p = new TracerProjectile()
   {
      datablock = "ESwordExpCreater";
      initialPosition = %pos;
      initialDirection = "0 0 3";
   };
}

datablock ShapeBaseImageData(ESwordStabbedImage1)
{
   shapeFile = "weapon_energy_vehicle.dts";
   offset = "-0.4 1.2 0";
   rotation = "1 0 0 -10";
};

datablock ShapeBaseImageData(ESwordStabbedImage2)
{
   shapeFile = "weapon_energy_vehicle.dts";
   offset = "-0.4 1.2 0.01";
   rotation = "-1.10478e-07 0.996195 -0.0871558 180";
};

function BeginRage(%obj) {
      %p = new TracerProjectile()
      {
         datablock = "ESwordExpCreater";
         initialPosition = %obj.getposition();
         initialDirection = "0 0 3";
      };
   %obj.mustRecharge = 1;
   %obj.enraged = 1;
   ScanForRageTargets(%obj);
   schedule(10000,0,"EndTheMadness", %obj);
   schedule(20000,0,"ResetAttacks",%obj);
}

function EndTheMadness(%obj) {
   %obj.enraged = 0;
}

function ScanForRageTargets(%obj) {
   if(!%obj.enraged) {
      return;
   }
   InitContainerRadiusSearch(%obj.getPosition(), 50, ($TypeMasks::VehicleObjectType | $TypeMasks::PlayerObjectType));
   while ((%searchResult = containerSearchNext()) != 0) {
	%objtarget = firstWord(%searchResult);
	   if(isObject(%objtarget) && %objTarget !$= %obj.player && %objtarget.team != %obj.team){
	      %trgtype = %objtarget.getClassName();
	      if(%trgtype $= "HoverVehicle" || %trgtype $= "Player" || %trgtype $= "FlyingVehicle")
             %targets = %targets SPC %objtarget;  //generate a list of targets
       }
   }
   if(%targets){
	  %target = firstWord(%targets);
	  %targets = getWords(%targets,1,4);
      //Ok now that we have our list, Determine the proper action
      PhantomRageAttack(%obj, %target, %targets);
   }
   else {
      schedule(1000,0,"ScanForRageTargets", %obj);
   }
}

function PhantomRageAttack(%obj, %target, %targets) {
   if(!isObject(%obj) || %obj.getState() $= "dead") {
      return;
   }
   if(!isObject(%target)){
	  if(%targets){
	     %target = firstWord(%targets);
	     %targets = getWords(%targets,1,4);
	  }
      schedule(100, 0, "ScanForRageTargets", %obj);
   }
   //time to just rape the target
      %p = new TracerProjectile()
      {
         datablock = "ESwordExpCreater";
         initialPosition = %target.getposition();
         initialDirection = "0 0 3";
      };
      %obj.setTransform(vectorAdd(%target.getPosition(), "2 0 3"));
      //heavily damage the enemy
      %target.damage(%obj, %target.position, 1.4, $DamageType::DESword); //DIE
      //heal yourself :)
      %obj.applyRepair(1.4);
      schedule(1000, 0, "ScanForRageTargets", %obj);
}

function ShredStartProjectile::onCollision(%data,%projectile,%targetObject,%modifier,%position,%normal) {
   if (%targetObject.getClassName() $= "Player") {
      %killer = %projectile.sourceObject;
      %killer.mustRecharge = 1;
      %killer.setMoveState(true);
      schedule(8000,0,"ResetAttacks",%killer);
      %targetObject.setMoveState(true);
      %targetObject.clearInventory();
      ShredEmUp(%killer, %targetObject);
   }
}

function ShredEmUp(%killer, %victom) {
   %killer.setTransform(vectorAdd(%victom.getPosition(), "2 0 3"));
   %killer.isShielded2 = true; //shield the killer
   %victom.isShielded2 = true; //shield the victom from being killed from outside
   DoShredBoom(0, %victom, %killer);
   schedule(400,0,"DoShredBoom",0, %victom, %killer);
   schedule(800,0,"DoShredBoom",0, %victom, %killer);
   schedule(1200,0,"DoShredBoom",0, %victom, %killer);
   schedule(1600,0,"DoShredBoom",0, %victom, %killer);
   schedule(2000,0,"DoShredBoom",0, %victom, %killer);
   schedule(2400,0,"DoShredBoom",0, %victom, %killer);
   schedule(2800,0,"DoShredBoom",0, %victom, %killer);
   schedule(3200,0,"DoShredBoom",0, %victom, %killer);
   schedule(3600,0,"DoShredBoom",0, %victom, %killer);
   schedule(4000,0,"DoShredBoom",0, %victom, %killer);
   schedule(4400,0,"DoShredBoom",0, %victom, %killer);
   schedule(4800,0,"DoShredBoom",0, %victom, %killer);
   schedule(5200,0,"DoShredBoom",0, %victom, %killer);
   schedule(5600,0,"DoShredBoom",0, %victom, %killer);
   schedule(6000,0,"DoShredBoom",0, %victom, %killer);
   schedule(6100,0,"DoShredBoom",1, %victom, %killer);
}

function DoShredBoom(%kill, %targ, %src) {
   if(%kill == 1) {
      if(%src.usingShieldGen == false) {
         %src.isShielded2 = false;
         %src.setMoveState(false);
      }
      %targ.isShielded2 = false;
      %targ.damage(%src, %targ.position, 99999, $DamageType::DESword); //DIE
   }
   else {
      %p = new TracerProjectile()
      {
         datablock = "ESwordExpCreater";
         initialPosition = %targ.getposition();
         initialDirection = "0 0 3";
      };
      %targ.blowup(); //hahaha!!!
   }
}

function SwordThrowProjectile::onCollision(%data,%projectile,%targetObject,%modifier,%position,%normal) {
   if (%targetObject.getClassName() $= "Player") {
      %projectile.sourceObject.mustRecharge = 1;
      schedule(6000,0,"ResetAttacks",%projectile.sourceObject);
      %targetObject.setMoveState(true);
      %targetObject.clearInventory();
      //fun :)
      %targetObject.mountImage(ESwordStabbedImage1,7);
      %targetObject.mountImage(ESwordStabbedImage2,8);
      %pos1 = vectorAdd(%targetObject.getPosition(), "-0.4 1.2 0");
      %pos2 = vectorAdd(%targetObject.getPosition(), "-0.4 1.2 0.1");
      %targetObject.diebeam1 = new TargetProjectile()
      {
         datablock = "DESwordBeam";
         initialPosition = %pos1;
         initialDirection = %targetObject.getPosition();
         sourceSlot = 7;
         sourceObject = %targetObject;
      };
      %targetObject.diebeam2 = new TargetProjectile()
      {
         datablock = "DESwordBeam";
         initialPosition = %pos2;
         initialDirection = %targetObject.getPosition();
         sourceSlot = 8;
         sourceObject = %targetObject;
      };
      //Sword Die Loop
      ImpaleKill(%targetObject, %projectile.sourceObject);
      %p = new TracerProjectile()
      {
         datablock = "ESwordExpCreater";
         initialPosition = %targetObject.getposition();
         initialDirection = "0 0 3";
      };
   }
}

function ImpaleKill(%toDie, %src) {
   if(!isObject(%toDie) || %toDie.getState() $= "dead") {
      %toDie.diebeam1.delete();
      %toDie.diebeam2.delete();
      return;
   }
   %toDie.damage(%src, %toDie.position, 0.1, $DamageType::DESwordThrow); //slowly :)
   schedule(1000,0,"ImpaleKill", %toDie, %src);
}

function ResetAttacks(%ply) {
   %ply.mustRecharge = 0;
}
